<?php
	class Article {
		var $title;
		var $comment;
		var $category;
		var $address;
		var $createdTime;
		var $lat;
		var $lon; 
	
		function importFromRequest($request) {
			$this->title = htmlspecialchars($request['title']);
			$this->comment = htmlspecialchars($request['comment']);
			$this->category = $request['category'];
			$this->address = $request['address'];
			$this->lat = $request['lat'];
			$this->lon = $request['lon'];
		}

		function getErrorMessage() {
			//$titleLength = mb_strlen($this->title, "UTF-8");
			$titleLength = $this->countTitleLength($this->title);
			$commentLength = mb_strlen($this->comment, "UTF-8");

			// エラー判定を行う
			if($this->title == NULL) {
				$errorMessage = "タイトルを入力してください。";
			} elseif ($titleLength > 32) {
				$errorMessage = "タイトルは32文字以内で入力してください。";
			} elseif ($this->category == NULL) {
				$errorMessage = "カテゴリーを選択してください。";
			} elseif($commentLength > 1024) {
				$errorMessage = "コメントは1024文字以内で入力してください。";
			} else {
				$errorMessage = NULL;
			}
			return $errorMessage;
		}

		function countTitleLength($title) {
			// "、<、>、 を一時的に戻す
			$title = str_replace('&nbsp;', ' ', $title);
			$title = str_replace('&lt;', '<', $title);
			$title = str_replace('&gt;', '>', $title);
			$title = str_replace('&quot;', '"', $title);

			return mb_strlen($title, "UTF-8");
		}

		function setCreatedTime() {
			$this->createdTime = date("Y/m/d H:i:s", time());
		}
	}
?>

