<!--
	articles.php
	記事一覧表示画面
	author: Yuki Anezaki
	history: 
		2006/12/30 姉崎 第1版作成
		2007/01/22 姉崎 構造化
-->

<!-- ライブラリ読込 -->
<?php 
include 'refine.php';
include 'connect.php';
include 'initialization.php';
include 'getDBdata.php';
?>

<!-- 入力 -->
<?php

//GPSデータの取得
//検索フォームの文字を取得
//日時指定のプルダウンの値を取得
$lat = $_REQUEST[lat];
$lon = $_REQUEST[lon];
$keyword = htmlspecialchars($_REQUEST[keyword]);
$time = $_REQUEST[period];
$pageNum = $_REQUEST["page"];

?>

<!-- 処理 -->
<?php

if(strlen($lat) > 8){
	$lat = substr($lat, 1, 8);
}
if(strlen($lon) > 9){
	$lon = substr($lon, 1, 9);
}

/*********************************************************************************/
/*									初期判断										 */
/* 					キャリア判定、GPS情報取得成功？、対応エリア内？						 */
/*********************************************************************************/
//携帯電話のキャリアを判定
careerCheck();

//GPSが取得できているのか、範囲内にいるのかCheck
$gpcheck = GPcheck($lat, $lon);

/*********************************************************************************/
/*				データベースを取得し、現在値と記事の位置情報を計算する。						 */
/* 					新たに配列を作成し、ID(key)と距離を格納。							 */
/*              			距離の近い順にソートする。								 */
/*********************************************************************************/
connect();


//投稿されたすべての記事の位置情報を取り出し、現在地からの距離を計算したあと、近い順に並び替える。
$array_distance = getDistanceArray($lat,$lon);

//現在地に近い順に並べた記事の「IDの配列」(id_array)をつくる
$id_array = array_keys($array_distance);


/*********************************************************************************/
/*				日付指定プルダウンのデータで表示するデータを絞り込む。						 */
/* 				条件に当てはまるデータのIDを保存する配列(time_array)を作る。				 */
/*********************************************************************************/

switch ($time) {
	case "1" :
		$from_time = "DATE_SUB(NOW(),INTERVAL 3 DAY)";
		break;
	case "2" :
		$from_time = "DATE_SUB(NOW(),INTERVAL 14 DAY)";
		break;
	case "3" :
		$from_time = "DATE_SUB(NOW(),INTERVAL 1 MONTH)";
		break;
	case "4" :
		$from_time = "DATE_SUB(NOW(),INTERVAL 3 MONTH)";
		break;
	case "5" :
		$from_time = "DATE_SUB(NOW(),INTERVAL 1 YEAR)";
		break;
	default :
		$from_time = "DATE('0000-00-00')";
}
//search_array(検索で絞り込んだID配列)をさらに時間で絞り込む
$time_id_array = timeRefine($from_time, $id_array);

/*********************************************************************************/
/*			検索キーワードを取得し、スペースごとに単語を抜き出し、検索語の準備をする。			 */
/* 				条件に当てはまるデータのIDを保存する配列(sarch_array)を作る。				 */
/* 					入力　検索単語（$keyword) 検索対象　($show_range)					 */
/* 					出力　検索単語が含まれる記事にしぼられたIDの配列						 */
/*********************************************************************************/
$fuzzied_id_array = getFuzzyReference($keyword, $time_id_array);

/*********************************************************************************/
/*				表示のために必要なデータをDBから取得し、準備をする							 */
/* 		タイトル取得&文字制限、カテゴリー取得＆アイコン取得、表示件数制限、ページ制御			 */
/*********************************************************************************/

//一画面で表示をする記事を制限
//ページ数を計算し、$pageNum で表示する範囲を制御
$arrayNum = count($fuzzied_id_array);
$arrayNum_ceil = ceil($arrayNum / 10);
$slice_refined_array = pageRestriction($pageNum, $fuzzied_id_array);

for ($i = 0; $i < 10; $i++) {
	if (!($slice_refined_array[$i] == null)) {
		
		//記事を取得
		$content = getContent($slice_refined_array[$i]);
		//タイトルの文字制限をかける
		$the_title[$i] = charSet($content[title]);
		//記事のカテゴリーを取得し、もとにimo_category DBからカテゴリーアイコンURLを取得する
		$category[$i] = getCategory($slice_refined_array[$i]);

	}
}
?>
<!--　処理用関数 -->
<?php
function pageRestriction($pageNum, $refined_array) {
	if ($pageNum == "") {
		$pageNum = 0;
	}
	if(count($refined_array) > 0){
		$slice_keys = array_slice($refined_array, $pageNum * 10, 10);		//表示する記事を指定
	}else{
		$slice_keys = null;
	}
	return $slice_keys;
}
?>

<!-- 表示　-->
<html>
<head>
<title>周辺記事</title>
<meta http-equiv="Content-Type" content="text/html;charset=utf-8">

</head>
<body>
<div id="bg">
<div align="center">
<font size=3>投稿記事</font><br>
<hr>
</div>

<?php

//記事の一覧を表示する
for ($i = 0; $i < 10; $i++) {
	if (!($slice_refined_array[$i] == null)) {
		$this_category = $category[$i];
		echo "<img src=\"$this_category[url]\" alt=\"$this_category[name]\" width=\"12\" height=\"12\" />" . //画像
		"<a href = \"content.php?id=$slice_refined_array[$i]&lat=$lat&lon=$lon\">" . //リンク
		"$the_title[$i] </a><br>"; //表示用タイトル
	}else{
		if($i == 0)	echo "該当記事が見つかりません。";
	}
}

//ページ制御
//ページ数から判断、?keyword=***＆でデータを送る。

if ($pageNum > 0) {
	$beforePage = $pageNum -1;
	echo "<br><a href=\"" . $_SERVER["PHP_SELF"] . "?keyword=$keyword&period=$time&lat=$lat&lon=$lon&page=$beforePage\">前へ</a> ";
} else {
	echo "<br>";
}
if ($arrayNum_ceil > $pageNum +1) {
	$nextPage = $pageNum +1;
	echo "<a href=\"articles.php?keyword=$keyword&period=$time&lat=$lat&lon=$lon&page=$nextPage\">次へ</a>";
}

?>
<hr>
検索語を入れてください
<br>
<form method="POST" action="<?php echo $_SERVER["PHP_SELF"]?>" > 
<input type="text" name="keyword" value="<?php echo $keyword?>">
<select name='period'>
<option <?php if(!($time >= 1)) echo " selected";?> value="0">期限なし</option>
<option <?php if($time=="1") echo " selected";?> value="1">最近３日間</option>
<option <?php if($time=="2") echo " selected";?> value="2">最近２週間</option>
<option <?php if($time=="3") echo " selected";?> value="3">最近１ヶ月</option>
<option <?php if($time=="4") echo " selected";?> value="4">最近３ヶ月</option>
<option <?php if($time=="5") echo " selected";?> value="5">最近１年</option>
</select>
<input type="submit" value="絞り込み">
<input type="hidden" name="lat" value="<?php echo $lat?>">
<input type="hidden" name="lon" value="<?php echo $lon?>">
<input type="hidden" name="page" value="<?php echo $page?>">
</form>

<hr>
[<a href="index.php">里撮トップ</a>]<!--里撮トップページへ-->
</body>
</html>


<!-- 表示用関数　-->
<?php

//タイトルの文字制限をかける
function charSet($char_target) {
	if (mb_strlen($char_target) >= 11) {
		$_the_title = mb_substr($char_target, 0, 9);
		$_the_title .= "...";
	} else {
		$_the_title = $char_target;
	}
	return $_the_title;
}
?>
