#!/usr/bin/perl
##
##メールを解析し、添付ファイルやヘッダ情報を取り出すプログラム
## shinora@crew.sfc.keio.ac.jp
## 070116 作成
##
use MIME::Base64;
use MIME::Parser;
use MIME::WordDecoder;
use Encode;
use utf8;

1;
##メールを解析し、添付ファイルやヘッダ情報を取り出す
sub getDataFromMail{
  $input = shift;
  # メールを解析する
  my $parser = new MIME::Parser;
  $parser->output_to_core(1);    # Keeps body analyzed internally
  $parser->tmp_recycling (1);    # Recycles the temporary stuff
  
  my $mail = $parser->parse($input) or die "error: Parse Error $parser->last_error";

  #ヘッダーの解析
  my %header = &decodeHeader($mail);
  if($header{'subject'} eq ""){
    die "error: invalid subject";
  }
  
  # 添付ファイルを取り出す
  my @fileList = &getImageFiles(\$mail);
  if(!defined @fileList){
    die "error: no attached picture file";
  }
  my %data;
  $data{'file'} = $fileList[0]->{'body'};#一番目だけを登録する
  $data{'contentId'} = &getContentId($header{'to'});
  $data{'title'} = $header{'subject'};
  $data{'fileName'} = $data{'contentId'}.".jpg";
  $data{'header'} = \$head;

  return %data;
}

#ヘッダーをデコードする
#全部もってくるような上手いやり方はないようだ
sub decodeHeader{
  my $entity = shift;
  my %header;
  #to
  $header{'to'} =decode('MIME-Header',$entity->head->get('to'));
  $header{'to'} =~ s/\n//g;

  #from
  $header{'from'} =  decode('MIME-Header',$entity->head->get('from'));
  $header{'from'} =~ s/\n//g;
  
  # Subject
  $header{'subject'} = decode('MIME-Header',$entity->head->get('subject'));
  $header{'subject'} =~ s/\n//g;

  return %header;
}

##メールの中身から画像とファイル名を取り出す
sub decodePart{
  my $entity = shift;
  my %file;
  if($entity->mime_type eq "image/jpeg"){
    my %file;
    #ファイル名を取り出す
    $file{'name'} = decode('MIME-Header',$entity->head->recommended_filename) or die "error: mail decode error";
    #ファイルの中身を取り出す
    $file{'body'} = $entity->bodyhandle->as_string;

    return %file;
  }else{
    return;
  }
}

#添付画像を取り出す
sub getImageFiles {
  my $e = shift;##メール本文
  my $entity =$$e;
  my @fileList ;#= ();

  #添付ファイル、および本文の中から、MIMEヘッダがjpegのものだけを取り出す
  if($entity->is_multipart){
    my $count = $entity->parts;
    for(my $i = 0; $i < $count; $i++){
      #メールは木構造になっているので、下があれば掘っていく
      my @returnValue =getImageFiles(\$entity->parts($i));
      if(@returnValue){
        push @fileList,@returnValue;
      }
    }
  }else{
    my %file = decodePart($entity);
    if(%file){
      push (@fileList,\%file);
    }
  }
  return @fileList;
}

#メールアドレスから記事IDを取得する
sub getContentId{
  my $to = shift;
  @tos = split(/,/,$to);
  foreach(@tos){
    if($FIX_MODE eq 'postfix'){
      if(/([0-9]*)$SUFFIX\@$MAIL_SERVER/){
        return $1;
      }
    }elsif ($FIX_MODE eq 'prefix'){
      if(/$SUFFIX([0-9]*)\@$MAIL_SERVER/){
        return $1;
      }
    }
  }
}

